#!/usr/bin/env python

import time
import sys
from blogfish.blogfish_functions import debug

class PassiveFishTPClient:

	def __init__(self, wfile, addr, pm):
		self.wfile = wfile
		self.addr = addr
		self.pm = pm
		self.messages = []
		
	def wait_forever(self):	
		while 1: time.sleep(600) # this thread never wakes

	def push(self, string): # this is in a separate thread
		self.messages.append(string)
		while self.messages: self.send()

	def send(self):
		message = self.messages.pop(0) # if message fails, it's lost
		start = "MESG %s\n" % len(message)
		message = start + message + "\n\n"
		try:
			debug("writing message to passive peer '%s'" % self.addr)
			self.wfile.write(message)
			self.pm.handle_success(self.addr) # resets the count
		except:
			debug("failed to write to wfile of " + self.addr)
			debug("exception was:")
			debug(repr(sys.exc_info()))
			self.pm.handle_failure(self.addr)

	
		
