#!/usr/bin/env python

import sys
import gconf
import getopt

Debug = 0
# HACK
Port = None

def debug(dstr):
	global Debug
	if Debug: sys.stderr.write(dstr + "\n")
	#import os # DO NOT DO THIS...
	#os.system("logger '" + dstr + "'")

def get_config_value(key, val=None):
	if not val:
		client = gconf.client_get_default()
		key = "/apps/blogfish/" + key
		val = client.get(key)
	t = val.type
	if t == gconf.VALUE_STRING:
		return val.get_string()
	elif t == gconf.VALUE_FLOAT:
		return val.get_float()
	elif t == gconf.VALUE_INT:
		return val.get_int()
	elif t == gconf.VALUE_BOOL:
		return val.get_bool()
	debug("unknown gconf value type... returning string")
	return val.to_string()
	

def set_config_value(key, val):
	debug("setting %s to '%s'" % (key, val))
	key = "/apps/blogfish/" + key
	client = gconf.client_get_default()
	dflt = client.get_default_from_schema(key)
	t = dflt.type
	if t == gconf.VALUE_STRING:
		val = str(val)
		client.set_string(key, val)
	elif t == gconf.VALUE_FLOAT:
		val = float(val)
		client.set_float(key, val)
	elif t == gconf.VALUE_INT:
		val = int(val)
		client.set_int(key, val)
	elif t == gconf.VALUE_BOOL:
		val = bool(val)
		client.set_bool(key, val)
	else:
		debug("got unknown value type for gconf key '%s'" % key)
		# guess it's a string
		client.set_string(key, str(val))


def get_port():
	if Port is not None: return str(Port)
	client = gconf.client_get_default()
	if client.get_bool("/apps/blogfish/passiveServer"):
		return "PASV"
	else:
		return str(client.get_int("/apps/blogfish/port"))


def server_changed_callback(func):
	client = gconf.client_get_default()
	l = lambda *junk: func(get_port())
	client.notify_add("/apps/blogfish/port", l) 
	client.notify_add("/apps/blogfish/passiveServer", l)
